class SecretsManager(object):
    def __init__(self, boto_session, boto_config=None, endpoint_url=None):
        self.secrets_client = boto_session.client(
            "secretsmanager", config=boto_config, endpoint_url=endpoint_url
        )

    def get_secret(self, secret_id):
        secret_value_response = self.secrets_client.get_secret_value(SecretId=secret_id)
        if secret_value_response is None:
            raise ValueError("Secret was not found or can't be accessed.")
        return secret_value_response.get("SecretString")
