from datetime import datetime
from tic.shared.ubs.dtos.analysis.timing import UbsAnalysisTiming
from tic.shared.utils.date_util import utc_now


class YaraTiming(UbsAnalysisTiming):
    def __init__(
        self,
        process_start: datetime = None,
        rules_pulled: datetime = None,
        file_pulled: datetime = None,
        matches_computed: datetime = None,
        published_results: datetime = None,
    ):
        super().__init__()
        self.process_start = process_start if process_start is not None else utc_now()
        self.rules_pulled = rules_pulled
        self.file_pulled = file_pulled
        self.matches_computed = matches_computed
        self.published_results = published_results

        super().decode_settings.update(
            {
                "process_start": self.from_iso_8601_if_present,
                "rules_pulled": self.from_iso_8601_if_present,
                "file_pulled": self.from_iso_8601_if_present,
                "matches_computed": self.from_iso_8601_if_present,
                "published_results": self.from_iso_8601_if_present,
            }
        )

        super().encode_settings.update(
            {
                "process_start": self.to_iso_8601_if_present,
                "rules_pulled": self.to_iso_8601_if_present,
                "file_pulled": self.to_iso_8601_if_present,
                "matches_computed": self.to_iso_8601_if_present,
                "published_results": self.to_iso_8601_if_present,
            }
        )
