from .customer_metadata import CustomerMetadata


class ResponsePscMetadata(CustomerMetadata):
    def __init__(
        self,
        org_key=None,
        sensor_version=None,
        sha256=None,
        sha256_truncated=None,
        original_md5=None,
        original_size=None,
        test=False,
    ):
        super().__init__(
            sha256_truncated=sha256_truncated,
            sha256=sha256,
            original_md5=original_md5,
            original_size=original_size,
            org_key=org_key,
            test=test,
        )
        self.sensor_version = sensor_version

    def is_valid(self):
        return not (
            self.org_key is None
            or self.sha256_truncated is None
            or self.original_md5 is None
            or self.original_size is None
            or self.sha256 is None
        )
